/// <reference types="node" />
import stream from 'stream';
import postgres from 'postgres';
interface LevelStreamOption {
    gt?: string;
    gte?: string;
    lt?: string;
    lte?: string;
    reverse?: boolean;
    limit?: number;
    keys?: boolean;
    values?: boolean;
}
export interface Level<T> {
    put(key: string, value: T, fn?: (err: Error | null, value: T | null) => unknown): void;
    get(key: string, fn?: (err: Error | null, value: T | null) => unknown): void;
    del(key: string, fn?: (err: Error | null) => unknown): void;
    createReadStream(options?: LevelStreamOption): stream.Readable;
}
export declare const level: <T>(sql: postgres.Sql<never>, table: string) => Level<T>;
export {};
